package pkmn

import (
	"strings"
)

var charTable = [256]string{
	" ", "À", "Á", "Â", "Ç", "È", "É", "Ê", "Ë", "Ì", " ", "Î", "Ï", "Ò", "Ó", "Ô",
	"Œ", "Ù", "Ú", "Û", "Ñ", "ß", "à", "á", " ", "ç", "è", "é", "ê", "ë", "ì", " ",
	"î", "ï", "ò", "ó", "ô", "œ", "ù", "ú", "û", "ñ", "º", "ª", "ᵉʳ", "&", "+", " ",
	" ", " ", " ", " ", "N.", "=", ";", " ", " ", " ", " ", " ", " ", " ", " ", " ",
	"▯", "¿", "¡", "PK", "MN", "PO", "Ké", " ", " ", " ", "Í", " %", "(", ")", " ", " ",
	" ", " ", " ", " ", "Pco", " ", " ", " ", "â", " ", " ", " ", " ", " ", " ", " ",
	" ", " ", " ", " ", " ", " ", " ", " ", " ", "⬆", "⬇", "⬅", "➡", "*", "*", "*",
	"*", "*", "*", "*", "ᵉ", "<", ">", " ", " ", " ", " ", " ", " ", " ", " ", " ",
	" ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ",
	" ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ",
	"ʳᵉ", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "!", "?", ".", "-", "・",
	"...", "«", "»", "‘", "’", "♂", "♀", "PkDlr", ",", "×", "/", "A", "B", "C", "D", "E",
	"F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U",
	"V", "W", "X", "Y", "Z", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k",
	"l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "▶",
	":", "Ä", "Ö", "Ü", "ä", "ö", "ü", " ", " ", " ", " ", " ", " ", " ", " ", " ",
}

func DecodeText(text []byte) string {
	var sb strings.Builder
	for _, c := range text {
		if c == 0xff {
			break
		}

		char := charTable[c]
		sb.WriteString(char)
	}

	return sb.String()
}

func EncodeText(text string, length uint32) []byte {
	var bb = make([]byte, length)
	for i := range bb {
		bb[i] = 0xFF
	}

	for i, c := range text {
		cs := string(c)
		for j, t := range charTable {
			if t == cs {
				bb[i] = byte(j)
				break
			}
		}
	}

	return bb
}
